mod Ul04 logic: 'cl'

incl Mtex

incl Mtexg

incl Mtexnt

incl Maux

loc rem 
  \para \bf  PRÉMIOVA ÚLOHA Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 12.81.21 
  \para* \it  Dátum:  \end štvrtok 21.5.2015 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1415ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohu: \bf  \it  8  \end  \end. 
   \item \para Úlohy riešte \bf  \it  samostatne!  \end  \end 
  \end
  \para Úlohu treba odovzdať do 26.5.2015 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Downloadable lecture notes available through the web page of 
         the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Symbolic Expressions.  \end 

rem 
  \para \bf  Section. Numeric Terms.  \end 

rem 
  \para \bf  [CL] Remark.  \end See the auxiliary module \it  Maux*  \end. 

rem 
  \para \bf  Subsection. Additive Normal Form.  \end 

rem 
  \para \bf  Auxiliary predicate.  \end 
  \eq* 
    Is_at(t) <-> \e t1\e t2 t = At(t1,t2)
  \end

pred Is_at 
  Is_at At(t1,t2)

rem 
  \para \bf  Multiplicative terms.  \end 

pred Mterm 
  Mterm Ct(n)
  Mterm Vt(i)
  Mterm Mt(t1,t2) <- Mterm(t1) & Mterm(t2)

rem 
  \para \bf  [CL] \ft Mterm \end-case analysis.  \end Syntax: 
  \eq* 
    'case Mterm ; <term>'
  \end
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_case Tex_f2_g_x_sc(Mterm,t) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_assum Mterm(t),
                            Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f2_g_eq(t,
                                                                           Vt(i)),
                                              Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f2_g_eq(t,
                                                                                             Ct(n)),
                                                                Tex_f1_g_x_assum Tex_f2_g_and(Tex_f2_g_eq(t,
                                                                                                          Mt(t1,
                                                                                                             t2)),
                                                                                              Tex_f2_g_and(Mterm(t1),
                                                                                                           Mterm(t2))))))
         \end
         \para where \ft i \end, \ft n \end, \ft t1 \end and \ft t2 \end are new 
         variables \it  (eigen-variables)  \end. 
  \end

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Mterm(t) -> ~Is_at(t)
  \end
  \para \it  Hint.  \end By \ft Mterm \end-case analysis on \ft t \end. 

thm Mterm_is_not_at
  Mterm(t) -> ~Is_at(t)

rem 
  \para \bf  Terms in additive normal form.  \end 

pred Anf 
  Anf(t) <- Mterm(t)
  Anf(t) <- ~Mterm(t) & t = At(t1,t2) & Anf(t1) & Anf(t2)

rem 
  \para \bf  [CL] \ft Anf \end-case analysis.  \end Syntax: 
  \eq* 
    'case Anf ; <term>'
  \end
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_case Tex_f2_g_x_sc(Anf,t) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_assum Anf(t),
                            Tex_f2_g_x_branch(Tex_f1_g_x_assum Mterm(t),
                                              Tex_f1_g_x_assum Tex_f2_g_and(Tex_f1_g_not Mterm(t),
                                                                            Tex_f2_g_and(Tex_f2_g_eq(t,
                                                                                                     Mt(t1,
                                                                                                        t2)),
                                                                                         Tex_f2_g_and(Anf(t1),
                                                                                                      Anf(t2))))))
         \end
         \para where \ft t1 \end and \ft t2 \end are new variables \it  
         (eigen-variables)  \end. 
  \end

rem 
  \para \bf  Exercise.  \end Show that the principle of \ft Anf \end-induction 
  is admissible in Peano arithmetic. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 
  \para \it  [CL] Hint.  \end Reduce the induction on \ft t \end to course of 
  values induction with measure \ft |t| \end. Recall that the pair size function 
  \ft |x| \end, written as \it  |x|  \end, is defined in the module \it  
  Standard  \end. 

theory Anf_induction

pred A 'Tex1_g_appl_phi_sb'

axiom Base_case
  Mterm(t) -> A(t)

axiom Induction_step
  ~Mterm(t) & t = At(t1,t2) & Anf(t1) & Anf(t2) -> A(t)

thm Conclusion
  Anf(t) -> A(t)

end theory Anf_induction

rem 
  \para \bf  [CL] \ft Anf \end-induction.  \end 
  \header* fun R 'Tex1_g_appl_phi_sb' \end Syntax: 
  \eq* 
    'ind[*] Anf ; <variable> [; <variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(Anf,t) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_imp(Anf(t),R(t)),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_imp(Mterm(t),
                                                                           R(t)),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(Tex_f1_g_not Mterm(t),
                                                                                        Tex_f2_g_and(Tex_f2_g_eq(t,
                                                                                                                 Mt(t1,
                                                                                                                    t2)),
                                                                                                     Tex_f2_g_and(R(t1),
                                                                                                                  R(t2)))),
                                                                           R(t))))
         \end
         \para where \ft t1 \end and \ft t2 \end are new variables \it  
         (eigen-variables)  \end. 
  \end

rem 
  \para \bf  Transformation of terms into additive normal form.  \end 

fun/2 Mul_ma 
  Mul_ma(s,t) = Mt(s,t) <- ~Is_at(t)
  Mul_ma(s,t) = At(Mul_ma(s,t1),Mul_ma(s,t2)) <- Is_at(t) & t = At(t1,t2)

fun/2 Mul_aa 
  Mul_aa(s,t) = Mul_ma(s,t) <- ~Is_at(s)
  Mul_aa(s,t) = At(Mul_aa(s1,t),Mul_aa(s2,t)) <- Is_at(s) & s = At(s1,s2)

fun Anf_from 
  Anf_from Vt(i) = Vt(i)
  Anf_from Ct(n) = Ct(n)
  Anf_from At(t1,t2) = At(Anf_from(t1),Anf_from(t2))
  Anf_from Mt(t1,t2) = Mul_aa(Anf_from(t1),Anf_from(t2))

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Mterm(s) & Anf(t) -> Anf Mul_ma(s,t)
  \end
  \eq* 
    Mterm(s) & Anf(t) -> Den(Mul_ma(s,t),v) = Den(Mt(s,t),v)
  \end
  \para \it  Hint.  \end By \ft Anf \end-induction on \ft t \end. 

thm Mul_ma_anf
  Mterm(s) & Anf(t) -> Anf Mul_ma(s,t)

thm Mul_ma_den
  Mterm(s) & Anf(t) -> Den(Mul_ma(s,t),v) = Den(Mt(s,t),v)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Anf(s) & Anf(t) -> Anf Mul_aa(s,t)
  \end
  \eq* 
    Anf(s) & Anf(t) -> Den(Mul_aa(s,t),v) = Den(Mt(s,t),v)
  \end
  \para \it  Hint.  \end By \ft Anf \end-induction on \ft s \end. 

thm Mul_aa_anf
  Anf(s) & Anf(t) -> Anf Mul_aa(s,t)

thm Mul_aa_den
  Anf(s) & Anf(t) -> Den(Mul_aa(s,t),v) = Den(Mt(s,t),v)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Term(t) -> Anf Anf_from(t)
  \end
  \eq* 
    Term(s) & Term(t) -> Den(Mul_aa(s,t),v) = Den(Mt(s,t),v)
  \end

thm Anf_from_anf
  Term(t) -> Anf Anf_from(t)

thm Anf_from_den
  Term(t) -> Den(Anf_from(t),v) = Den(t,v)

